#include <stdlib.h>

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

float AVRIDLE;

typedef struct noidle {
	float jump;
	float last;
	float next;
	float idle;
	struct noidle *precedant;
	struct noidle *suivant;
	void (*funcptr) (void);
} idle;

struct noidle *celuici, *precedant, *suivant;

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================
float lastsecond, sumidle;

float NOiD_iDLE_loop(float time)
{
	float wait;
	if ((precedant != NULL)&&(suivant != NULL))
	{
		celuici = precedant;
		while (celuici != NULL)
		{
			if (celuici->next <= time)
			{
				if (celuici->funcptr != NULL)
				{
					celuici->last = celuici->next;
					celuici->next = time + celuici->jump;
					celuici->idle = 0;
					//celuici = suivant;
					wait = 0;
					celuici->funcptr();
				}
			} else {
				celuici->idle = celuici->next - time;
				if (celuici->idle <= wait)
				{	wait = celuici->idle;	}
			}
			celuici = celuici->suivant;
		}
	}
	if (AVRIDLE >= (lastsecond+1))
	{
		AVRIDLE = sumidle;
		sumidle = 0;	
	}
	sumidle += wait;
	return wait;
}

//================================================================================================
//================================================================================================
//================================================================================================

idle * NOiD_iDLE_create(float interval,void (*function)(void))
{
	idle * this;
	if ((precedant == NULL)&&(suivant == NULL))
	{
		this = malloc(sizeof(idle));
		this->precedant = NULL;
		this->suivant = NULL;
		precedant = this;
		suivant = this;
			this->jump = interval;
			this->funcptr = function;
	} else {
		if (precedant == suivant)
		{
			this = malloc(sizeof(idle));
			suivant = this;
			suivant->precedant = precedant;
			suivant->suivant = NULL;
			precedant->precedant = NULL;
			precedant->suivant = suivant;
				this->jump = interval;
				this->funcptr = function;
		} else {
			if (suivant->suivant == NULL)
			{
				this = malloc(sizeof(idle));
				this->precedant = suivant;
				this->suivant = NULL;
				suivant->suivant = this;
				suivant = this;
					this->jump = interval;
					this->funcptr = function;
			}
		}
	}
	return this;
}

//================================================================================================
//================================================================================================
//================================================================================================

void NOiD_iDLE_destroy(idle *this)
{
	if (this != NULL)
	{
		if (precedant == suivant)
		{
			precedant = NULL;
			suivant = NULL;
			free(this);
		} else {
			if (this->precedant == NULL)
			{
				this->precedant->suivant = NULL;
				precedant = this->suivant;
				free(this);
			} else {
				if (this->suivant == NULL)
				{
					this->precedant->suivant = NULL;
					suivant = this->precedant;
					free(this);
				} else {
					this->precedant->suivant = this->suivant;
					this->suivant->precedant = this->precedant;
					free(this);
				}
			}
		}
	}
}

//================================================================================================
//================================================================================================
//================================================================================================
